/**
* 채팅 서버
*/
var net = require('net');
var readline = require('readline');

var argv = process.argv
var _HOST_ = argv[2]?argv[2]:'127.0.0.1';
var _PORT_ = argv[3]?argv[3]:'8000';

var makeMsg = function(msg,who,level,direction){
	if(!direction) direction = 'C';
	if(!level) level = '1';
	if(!who) who = '-';
	var spt = ' ';
	return direction+spt+level+spt+who+spt+msg;
}
var parseMsg = function(msg){
	var arr = msg.match(/^(S|C) (\d) ([^\s]*) (.*)$/);
	if(arr){
		arr.shift()
		return arr;
	}
	return ['X','0','_ERROR_','ERROR'];
}

var def_rl_events={
	 "line":function(cmd){
		var line = cmd.trim();
		if(line.length==0){
			show_prompt();
			return;
		}
		client.write(makeMsg(line));
		show_prompt();
	 }
	,"close":function(cmd){
		console.log('goodbye!');
		 client.end();
		process.exit(0);
	}
}


var def_socket_event = {
	"connect":function() {//console.log('server connect');
	show_prompt();
	}
	,"data":function(b) {//console.log('server data');
		var in_msg = b.toString('utf-8').trim();
		if(in_msg.length==0){

		}else if(b[0]=='C'){
			//console.log('out : '+in_msg);
			show_prompt();
		}else{
			var arr = parseMsg(in_msg);
//			console.log('in : '+in_msg);	
			switch(arr[1]){
				case '1':console.log('['+arr[2]+'] '+arr[3]);
					break;
				case '2':console.log('<알림> '+arr[3]);
					break;
				case '3':
					break;
				default:
					break;
			}
			show_prompt();
		}
	}
	,"end":function() {console.log('server end');
	}
	,"timeout":function() {console.log('server timeout');}
	,"drain":function() {
		//console.log('server drain');
	}
	,"error":function(e) {console.log('server error');}
	,"close":function(had_error) {console.log('server close');
		if(had_error){ console.log('error close'); }
		rl.close()
	}
}


var show_prompt = function(){
	rl.prompt();
}

var nick = 'N'+(new Date()).getTime();

var client = new net.Socket()
client.setEncoding('utf-8');
client.connect(_PORT_, _HOST_);
for(var x in def_socket_event){
	client.on(x,def_socket_event[x]);
}

var rl = readline.createInterface(process.stdin, process.stdout, null);
for(var x in def_rl_events){
	rl.on(x,def_rl_events[x]);
}

console.log('Start Client');
var prefix = '> ';
rl.setPrompt(prefix,prefix.length);


/*
// test
console.log(":"+parseMsg('C 0 xxx tttrtrtrt  asda sd\trt').join('_'));
var x = parseMsg('C 0 xxx tttrtrtrt  asda sd\trt');
console.log(":"+makeMsg(x[3],x[2],x[1],x[0]));
console.log(":"+parseMsg('X 0 xxx tttrtrtrtrt').join('_'));
//*/