/**
* 채팅 서버
*/
/*
메세지 구조
방향 레벨 누가 메세지
반향 : S from server , C from client
레벨 : 0 에러 , 1 기본, 2 공지
누가 : 사용자명
메세지 : 전달 내용
S 0 user1 안녕하세요 
C 0 user1 안녕하세요 
S 1 admin 공지사항
*/
var net = require('net');
var argv = process.argv
var _HOST_ = argv[2]?argv[2]:'127.0.0.1';
var _PORT_ = argv[3]?argv[3]:'8000';

var makeMsg = function(msg,who,level,direction){
	if(!direction) direction = 'S';
	if(!level) level = '1';
	if(!who) who = '---';
	var spt = ' ';
	return direction+spt+level+spt+who+spt+msg;
}
var parseMsg = function(msg){
	var arr = msg.match(/^(S|C) (\d) ([^\s]*) (.*)$/);
	if(arr && arr.length == 5){
		arr.shift()
		return arr;
	}
	return ['X','0','#SERVER#','ERROR'];
}

var def_socket_event = {
	"connect":function() {//console.log('server connect');
		sockets.push(this);
		this.nick = 'N'+((++invite_cnt)%10000)
		fn_broadcast('',this.nick+"님이 입장하셨습니다. 현재 총 "+sockets.length+"분이 계십니다.",'#SERVER#','2');
		fn_singlecast(this,"당신에 닉네임은 "+this.nick+"입니다. '/nick 닉네임' or '/닉 닉네임' 으로 변경하실 수 있습니다.",'#SERVER#','2');
	}
	,"data":function(b) {//console.log('server data');
		if(b.trim().length==0){
			return;
		}
		var arr = parseMsg(b.trim())
		if(arr[3].indexOf('/nick')==0 || arr[3].indexOf('/닉')==0){
			var n = arr[3].split(' ');
			if(n.length<2){ 
				fn_singlecast( this,"잘못된 입력입니다.",'#SERVER#','2');
			}else{
				var nick = n[1].trim();
				var m = this.nick+"님이 "+nick+"로 이름을 바꾸셨습니다.";
				fn_broadcast('',m,'#SERVER#','2');
				var m = "새로운 닉네임은 "+nick+"입니다.";
				fn_singlecast( this,m,'#SERVER#','2');
				this.nick =  nick
			}
		}else if(arr[3].indexOf('/quit')==0 || arr[3].indexOf('/끝')==0){
			this.end();
		}else if(arr[3].indexOf('/help')==0 || arr[3].indexOf('/도움')==0){
			var m = ""
			fn_singlecast(this,"# 도움말 #",'#SERVER#','2');
			fn_singlecast(this,"/nick 닉네임 (or /닉 닉네임) : 닉네임 변경",'#SERVER#','2');
			fn_singlecast(this,"/quit (or /끝) : 접속 종료",'#SERVER#','2');
			fn_singlecast(this,"/help (or /도움)",'#SERVER#','2');
		
		}else{
			fn_broadcast(this,arr[3],this.nick,'1');

		}
	}
	,"end":function() {//console.log('server end');
	}
	,"timeout":function() {//console.log('server timeout');
	}
	,"drain":function() {//console.log('server drain');
	}
	,"error":function() {//console.log('server error');
	}
	,"close":function() {console.log('server close');
		for(var i=0,m=sockets.length;i<m;i++){
			if(sockets[i]===this){
				sockets.splice(i,1);
			}
		}
		fn_broadcast('',this.nick+"님이 퇴장하셨습니다.",'#SERVER#','2');
	}
}
var sockets = [];
var invite_cnt = 0;
var fn_broadcast = function(fs,msg,who,level,direction){
	var socket = null;
	var data = makeMsg(msg,who,level,direction);
	console.log("fn_broadcast():"+data);
	for(var i=0,m=sockets.length;i<m;i++){
		socket = sockets[i];
		if(socket === fs){continue;}
		socket.write(data);
	}
}
var fn_singlecast = function(fs,msg,who,level,direction){
	var socket = null;
	var data = makeMsg(msg,who,level,direction);
	console.log("fn_singlecast():"+data);
	fs.write(data);
}
//--- 서버 생성
var server = net.createServer(
	function(c){
		console.log('server connected');
		console.log('server.connections : '+server.connections);
		c.setEncoding('ascii')
		c.bufferSize = 1024;
		for(var x in def_socket_event){
			c.on(x,def_socket_event[x]);
		}
//		c.pipe(c);
	}
);
//--- 서버 리슨 동작
server.maxConnection = 10;
server.listen(_PORT_,_HOST_);


console.log('server start');
console.log('server.maxConnection : '+server.maxConnection);
